﻿/* 
    PASS Virtual Group Global Portuguese
    SQL Curiosities: A Curiosidade Matou O Gato
    2017-04-18 (version 1.01)
    Demo - The Mysterious Case of the Feline View
    André Melancia
    http://Andy.PT

    (C) 2016-2017, André Melancia


                                     ,
               ,-.       _,---._ __  / \
              /  )    .-'       `./ /   \
             (  (   ,'            `/    /|
              \  `-"             \'\   / |
               `.              ,  \ \ /  |
                /`.          ,'-`----Y   |
               (            ;        |   '
               |  ,-.    ,-'         |  /
               |  | (   |        hjw | /
               )  |  \  `.___________|/
               `--'   `--'

*/


--  +----------------------------------------------------------------+
--  | FELINE TASKS                                                   |
--  +----------------------------------------------------------------+

    -- WARNING: Run these scripts on an EMPTY database!

    -- INSTRUCTIONS: Run one statement at a time.
    

--  +----------------------------------------------------------------+
--  | Sharpening the claws                                           |
--  +----------------------------------------------------------------+

    USE PUSSYCAT;           -- Or whatever database you created!
                            -- Please don't run this on the Master, that's
                            -- just ugly!
    GO


    -- Altoug they usually have 9 lives, we're going to kill them faster...
	-- Note: "IF EXISTS" are ugly. First time these will generate errors
    --       Just accept the errors as part of a 9-lives feline's living ;)

    DROP VIEW     dbo.VIEW_Cats_Star;
	GO

    DROP VIEW     dbo.VIEW_Cats_AllFields;
	GO

    DROP VIEW     dbo.VIEW_Cats_StarRich;
	GO

    DROP TABLE    dbo.Cats;
    GO
	

--  +----------------------------------------------------------------+
--  | The Mysterious Case of View ABC                                |
--  +----------------------------------------------------------------+

    CREATE TABLE dbo.Cats
    (
        CatID      INT           NOT NULL,
        CatName    NVARCHAR(64)  NOT NULL,
        CatYear    INT           NOT NULL,
        CatPayment INT           NOT NULL,
        CONSTRAINT PK_Cats   PRIMARY KEY CLUSTERED  ( CatID ASC ) 
    );


    -- Insert some REAL top secret DISCO information
    INSERT INTO dbo.Cats
    (CatID, CatName, CatYear, CatPayment) 
    VALUES 
	( 1, 'Grumpy Cat',                   2012,  600),
	( 2, 'Schrody (Schrödinger''s cat)', 1935,  650), /* The name is correct and at the same time is incorrect - until someone asks the cat! */
	( 3, 'Garfield',                     1978,  700),
	( 4, 'Hobbes',                       1985,  750),
	( 5, 'Mr.Bigglesworth',              1997,  800),
	( 6, 'Sylvester',                    1941,  850),
	( 7, 'Simba',                        1994,  900),
	( 8, 'Tigger',                       1928,  850),
	( 9, 'Heathcliff',                   1973, 1000),
	(10, 'Simon''s Cat',                 2008, 2000),
	(11, 'Spot (Data''s cat)',           1991, 3000),
	(12, 'Top Cat',                      1961, 4000),
    (13, 'Fofinha',                      2001, 5000),
	(14, 'Leoa (the ''Mini-Cat'')',      2008, 6000);


    -- Feline curiosity technique
    SELECT * FROM dbo.Cats;
    GO


--  +----------------------------------------------------------------+
--  | Let's see this as a query and then as a view                   |
--  +----------------------------------------------------------------+

	GO

    -- Create view (star)
	CREATE VIEW dbo.VIEW_Cats_Star
	AS
    SELECT * FROM dbo.Cats;
    GO

    -- Create view (each field)
	CREATE VIEW dbo.VIEW_Cats_AllFields
	AS
    SELECT CatID, CatName, CatYear, CatPayment FROM dbo.Cats;
    GO

    -- Create view (star, limited)
	CREATE VIEW dbo.VIEW_Cats_StarRich
	AS
    SELECT x.*
	FROM ( SELECT * FROM dbo.Cats) AS x
	WHERE x.CatPayment >= 2000;
	GO


    -- [CURIOSITY BLOCK]
    -- This is what every feline is curious about...
    SELECT 'Query Star' AS What, * FROM dbo.Cats;
	GO
    SELECT 'Query AllF' AS What, CatID, CatName, CatYear, CatPayment FROM dbo.Cats;
	GO
    SELECT 'View Star'  AS What, * FROM dbo.VIEW_Cats_Star;
	GO
    SELECT 'View AllF'  AS What, * FROM dbo.VIEW_Cats_AllFields;
	GO
    SELECT 'View StarRich'  AS What, * FROM dbo.VIEW_Cats_StarRich;
	GO

    -- [STRUCTURE BLOCK]
	EXEC SP_Help         'VIEW_Cats_Star';
	EXEC SP_HelpText     'VIEW_Cats_Star';
	EXEC SP_Views_Rowset 'VIEW_Cats_Star';


--  +----------------------------------------------------------------+
--  | Now let's do some nasty feline tricks                          |
--  +----------------------------------------------------------------+

	-- Now insert a new "CatFeedingTime" DATETIME NULL field 
	--        at the end of the Cats table
	--        Run the [CURIOSITY BLOCK] again...


	-- That's strange. Let's take a look at the view definitions!
	--        Run the [STRUCTURE BLOCK]...




	-- Now insert a new "CatStuff" VARCHAR NULL field
	--        after "CatName" 
	--        Run the [CURIOSITY BLOCK] again...

	-- That's even stranger. Now the fields are wrong!
    -- Notice the WHERE in VIEW_Cats_StarRich is actually correct


	-- Now let's change some content
	UPDATE dbo.Cats
	SET    CatStuff = 'Hello, pá... ' + CONVERT(VARCHAR(9), CatID)
	WHERE  CatPayment < 2000;

	-- Now run the [CURIOSITY BLOCK] again...
	-- See the [STRUCTURE BLOCK], shouldn't the field after "CatName" be INT?



	-- Now delete the "CatName" field
	--        Run the [CURIOSITY BLOCK] again...


--  +----------------------------------------------------------------+
--  | Dog days...                                                    |
--  +----------------------------------------------------------------+
    
	-- Now let's fix this!
	EXEC SP_RefreshView 'VIEW_Cats_Star';
	EXEC SP_RefreshView 'VIEW_Cats_StarRich';
	
	--DBCC DROPCLEANBUFFERS;



--  +----------------------------------------------------------------+
--  | Playtime is over.                                              |
--  | Now it's time for a cat nap!                                   |
--  +----------------------------------------------------------------+
